/*
 * Kangaroo Punch MultiPlayer Game Server Mark II
 * Copyright (C) 2020-2021  Scott Duensing
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */


#ifndef LISTBOX_H
#define LISTBOX_H


#include "gui.h"
#include "widget.h"


typedef struct ListboxS {
	WidgetT         base;        // Must be first in every widget
	char           *title;
	char          **values;
	uint16_t        selected;    // values[offset + selected]
	int32_t         step;
	int32_t         offset;
} ListboxT;


uint16_t  listboxIndexGet(ListboxT *listbox);
void      listboxIndexSet(ListboxT *listbox, uint16_t index);
WidgetT  *listboxInit(WidgetT *widget, char *title);
void      listboxItemAdd(ListboxT *listbox, char *item);
void      listboxItemRemove(ListboxT *listbox, char *item);
ListboxT *listboxNew(uint16_t x, uint16_t y, uint16_t w, uint16_t h, char *title);
void      listboxStepSet(ListboxT *listbox, int32_t step);
void      listboxTitleSet(ListboxT *listbox, char *title);
char     *listboxValueGet(ListboxT *listbox);
void      listboxValueSet(ListboxT *listbox, char *value);


#endif // LISTBOX_H
